package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.auth.Subject;
import org.rhq.core.domain.measurement.Availability;
import org.rhq.core.domain.util.PageControl;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface AvailabilityGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.AvailabilityGWTService
     */
    void findAvailabilityForResource( int resourceId, org.rhq.core.domain.util.PageControl pc, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.measurement.Availability>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static AvailabilityGWTServiceAsync instance;

        public static final AvailabilityGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (AvailabilityGWTServiceAsync) GWT.create( AvailabilityGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "AvailabilityGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
