package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.criteria.GroupOperationHistoryCriteria;
import org.rhq.core.domain.criteria.ResourceOperationHistoryCriteria;
import org.rhq.core.domain.operation.GroupOperationHistory;
import org.rhq.core.domain.operation.ResourceOperationHistory;
import org.rhq.core.domain.util.PageList;
import org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.create.ExecutionSchedule;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface OperationGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findResourceOperationHistoriesByCriteria( org.rhq.core.domain.criteria.ResourceOperationHistoryCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.operation.ResourceOperationHistory>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void findGroupOperationHistoriesByCriteria( org.rhq.core.domain.criteria.GroupOperationHistoryCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.operation.GroupOperationHistory>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.OperationGWTService
     */
    void scheduleResourceOperation( int resourceId, java.lang.String operationName, org.rhq.core.domain.configuration.Configuration parameters, org.rhq.enterprise.gui.coregui.client.inventory.resource.detail.operation.create.ExecutionSchedule schedule, java.lang.String description, int timeout, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static OperationGWTServiceAsync instance;

        public static final OperationGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (OperationGWTServiceAsync) GWT.create( OperationGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "OperationGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
