package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.content.Repo;
import org.rhq.core.domain.criteria.RepoCriteria;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface RepoGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.RepoGWTService
     */
    void findReposByCriteria( org.rhq.core.domain.criteria.RepoCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.content.Repo>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static RepoGWTServiceAsync instance;

        public static final RepoGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (RepoGWTServiceAsync) GWT.create( RepoGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "RepoGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
