package org.rhq.enterprise.gui.coregui.client.gwt;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.criteria.ResourceCriteria;
import org.rhq.core.domain.resource.InventoryStatus;
import org.rhq.core.domain.resource.Resource;
import org.rhq.core.domain.resource.composite.RecentlyAddedResourceComposite;
import org.rhq.core.domain.util.PageControl;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ResourceGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void findResourcesByCriteria( org.rhq.core.domain.criteria.ResourceCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.Resource>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void getResourceLineage( int resourceId, AsyncCallback<java.util.List<org.rhq.core.domain.resource.Resource>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void getResourceLineageAndSiblings( int resourceId, AsyncCallback<java.util.List<org.rhq.core.domain.resource.Resource>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void findRecentlyAddedResources( long ctime, int maxItems, AsyncCallback<java.util.List<org.rhq.core.domain.resource.composite.RecentlyAddedResourceComposite>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void getPlatformForResource( int resourceId, AsyncCallback<org.rhq.core.domain.resource.Resource> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void uninventoryResources( int[] resourceIds, AsyncCallback<java.util.List<java.lang.Integer>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void updateResource( org.rhq.core.domain.resource.Resource resource, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void createResource( int parentResourceId, int newResourceTypeId, java.lang.String newResourceName, org.rhq.core.domain.configuration.Configuration newResourceConfiguration, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void getQueuedPlatformsAndServers( java.util.HashSet<org.rhq.core.domain.resource.InventoryStatus> statuses, org.rhq.core.domain.util.PageControl pc, AsyncCallback<java.util.Map<org.rhq.core.domain.resource.Resource,java.util.List<org.rhq.core.domain.resource.Resource>>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void importResources( java.lang.Integer[] resourceIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void ignoreResources( java.lang.Integer[] resourceIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGWTService
     */
    void unignoreResources( java.lang.Integer[] resourceIds, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ResourceGWTServiceAsync instance;

        public static final ResourceGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ResourceGWTServiceAsync) GWT.create( ResourceGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ResourceGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
