package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.criteria.ResourceGroupCriteria;
import org.rhq.core.domain.criteria.ResourceGroupDefinitionCriteria;
import org.rhq.core.domain.resource.group.GroupDefinition;
import org.rhq.core.domain.resource.group.ResourceGroup;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.user.client.rpc.RemoteServiceRelativePath;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface ResourceGroupGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void findResourceGroupsByCriteria( org.rhq.core.domain.criteria.ResourceGroupCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.group.ResourceGroup>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void findGroupDefinitionsByCriteria( org.rhq.core.domain.criteria.ResourceGroupDefinitionCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.resource.group.GroupDefinition>> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void ensureMembershipMatches( int groupId, int[] resourceIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void createResourceGroup( org.rhq.core.domain.resource.group.ResourceGroup group, int[] resourceIds, AsyncCallback<org.rhq.core.domain.resource.group.ResourceGroup> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.ResourceGroupGWTService
     */
    void deleteResourceGroup( int groupId, AsyncCallback<Void> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static ResourceGroupGWTServiceAsync instance;

        public static final ResourceGroupGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (ResourceGroupGWTServiceAsync) GWT.create( ResourceGroupGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "ResourceGroupGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
