package org.rhq.enterprise.gui.coregui.client.gwt;

import org.rhq.core.domain.auth.Subject;
import org.rhq.core.domain.criteria.SubjectCriteria;
import org.rhq.core.domain.util.PageList;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.ServiceDefTarget;
import com.google.gwt.core.client.GWT;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.rpc.ServiceDefTarget;

public interface SubjectGWTServiceAsync
{

    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void changePassword( java.lang.String username, java.lang.String password, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void createPrincipal( java.lang.String username, java.lang.String password, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void createSubject( org.rhq.core.domain.auth.Subject subjectToCreate, AsyncCallback<org.rhq.core.domain.auth.Subject> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void deleteSubjects( int[] subjectIds, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void login( java.lang.String username, java.lang.String password, AsyncCallback<org.rhq.core.domain.auth.Subject> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void logout( org.rhq.core.domain.auth.Subject subject, AsyncCallback<Void> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void updateSubject( org.rhq.core.domain.auth.Subject subjectToModify, AsyncCallback<org.rhq.core.domain.auth.Subject> callback );


    /**
     * GWT-RPC service  asynchronous (client-side) interface
     * @see org.rhq.enterprise.gui.coregui.client.gwt.SubjectGWTService
     */
    void findSubjectsByCriteria( org.rhq.core.domain.criteria.SubjectCriteria criteria, AsyncCallback<org.rhq.core.domain.util.PageList<org.rhq.core.domain.auth.Subject>> callback );


    /**
     * Utility class to get the RPC Async interface from client-side code
     */
    public static final class Util 
    { 
        private static SubjectGWTServiceAsync instance;

        public static final SubjectGWTServiceAsync getInstance()
        {
            if ( instance == null )
            {
                instance = (SubjectGWTServiceAsync) GWT.create( SubjectGWTService.class );
                ServiceDefTarget target = (ServiceDefTarget) instance;
                target.setServiceEntryPoint( GWT.getModuleBaseURL() + "SubjectGWTService" );
            }
            return instance;
        }

        private Util()
        {
            // Utility class should not be instanciated
        }
    }
}
